"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InjectionMetadata(ProtocolElement):
    """
    Metadata about injected data
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "author",
        "caseId",
        "caseVersion",
        "category",
        "cohortId",
        "groupId",
        "id",
        "program",
        "reportModelVersion",
        "version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import cva as cva_1_5_3
        from protocols.protocol_9_0 import participant as participant_1_5_0

        return {
            "organisation": cva_1_5_3.Organisation,
            "organisationNgis": participant_1_5_0.OrganisationNgis,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import cva as cva_1_5_3
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "assembly": reports_7_0_0.Assembly,
            "category": cva_1_5_3.Category,
            "program": reports_7_0_0.Program,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import cva as cva_1_5_3
        from protocols.protocol_9_0 import participant as participant_1_5_0
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "org.gel.models.report.avro.Assembly": reports_7_0_0.Assembly,
            "org.gel.models.cva.avro.Category": cva_1_5_3.Category,
            "org.gel.models.cva.avro.Organisation": cva_1_5_3.Organisation,
            "org.gel.models.participant.avro.OrganisationNgis": participant_1_5_0.OrganisationNgis,
            "org.gel.models.report.avro.Program": reports_7_0_0.Program,
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_5_3.InjectionMetadata,
        }

    __slots__ = [
        "author",
        "caseId",
        "caseVersion",
        "category",
        "cohortId",
        "groupId",
        "id",
        "program",
        "reportModelVersion",
        "version",
        "assembly",
        "authorVersion",
        "caseCreationDate",
        "caseLastModifiedDate",
        "organisation",
        "organisationNgis",
        "referralId",
        "referralTestId",
    ]

    def __init__(
        self,
        author,
        caseId,
        caseVersion,
        category,
        cohortId,
        groupId,
        id,
        program,
        reportModelVersion,
        version,
        assembly=None,
        authorVersion=None,
        caseCreationDate=None,
        caseLastModifiedDate=None,
        organisation=None,
        organisationNgis=None,
        referralId=None,
        referralTestId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.InjectionMetadata model.

        :param author:
            The author of the ReportedVariant, either tiering, exomiser, a given
            cip (e.g.: omicia) or a given GMCs user name
        :type author: str
        :param caseId:
            The case identifier
        :type caseId: str
        :param caseVersion:
            The case version. This is a correlative number being the highest value
            the latest version.
        :type caseVersion: int
        :param category:
            The category to which the case belongs.
        :type category: Category
        :param cohortId:
            The cohort identifier (the same family can have several cohorts)
        :type cohortId: str
        :param groupId:
            The family identifier
        :type groupId: str
        :param id:
            The entity identifier
        :type id: str
        :param program:
            The 100K Genomes program to which the reported variant belongs.
        :type program: Program
        :param reportModelVersion:
            Report avro models version
        :type reportModelVersion: str
        :param version:
            The entity version. This is a correlative number being the highest
            value the latest version.
        :type version: int
        :param assembly:
            The assembly to which the variants refer
        :type assembly: None | Assembly
        :param authorVersion:
            The author version of the ReportedVariant, either tiering, exomiser or
            a given cip. Only applicable for automated processes.
        :type authorVersion: None | str
        :param caseCreationDate:
            The creation date of the case (ISO-8601)
        :type caseCreationDate: None | str
        :param caseLastModifiedDate:
            The last modified date of the case (ISO-8601)
        :type caseLastModifiedDate: None | str
        :param organisation:
            The organisation responsible for this payload (Pedigree and
            CancerParticipant will correspond to the case owner and
            the ClinicalReport will correspond to the case assignee)
        :type organisation: None | Organisation
        :param organisationNgis:
            The NGIS organisation responsible for this payload
        :type organisationNgis: None | OrganisationNgis
        :param referralId:
            Referral unique identifier (only sent for NGIS cases)
        :type referralId: None | str
        :param referralTestId:
            Test unique identifier (only sent for NGIS cases)
        :type referralTestId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
